<?php

namespace RecruitCrm\LogicMelon\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCQueryJobTitle ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCQueryJobTitle
 * @subpackage Arrays
 */
class ArrayOfCQueryJobTitle extends AbstractStructArrayBase
{
    /**
     * The CQueryJobTitle
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \RecruitCrm\LogicMelon\StructType\CQueryJobTitle[]
     */
    public $CQueryJobTitle;
    /**
     * Constructor method for ArrayOfCQueryJobTitle
     * @uses ArrayOfCQueryJobTitle::setCQueryJobTitle()
     * @param \RecruitCrm\LogicMelon\StructType\CQueryJobTitle[] $cQueryJobTitle
     */
    public function __construct(array $cQueryJobTitle = array())
    {
        $this
            ->setCQueryJobTitle($cQueryJobTitle);
    }
    /**
     * Get CQueryJobTitle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \RecruitCrm\LogicMelon\StructType\CQueryJobTitle[]|null
     */
    public function getCQueryJobTitle()
    {
        return isset($this->CQueryJobTitle) ? $this->CQueryJobTitle : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCQueryJobTitle method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCQueryJobTitle method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCQueryJobTitleForArrayConstraintsFromSetCQueryJobTitle(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCQueryJobTitleCQueryJobTitleItem) {
            // validation for constraint: itemType
            if (!$arrayOfCQueryJobTitleCQueryJobTitleItem instanceof \RecruitCrm\LogicMelon\StructType\CQueryJobTitle) {
                $invalidValues[] = is_object($arrayOfCQueryJobTitleCQueryJobTitleItem) ? get_class($arrayOfCQueryJobTitleCQueryJobTitleItem) : sprintf('%s(%s)', gettype($arrayOfCQueryJobTitleCQueryJobTitleItem), var_export($arrayOfCQueryJobTitleCQueryJobTitleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CQueryJobTitle property can only contain items of type \RecruitCrm\LogicMelon\StructType\CQueryJobTitle, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CQueryJobTitle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\CQueryJobTitle[] $cQueryJobTitle
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfCQueryJobTitle
     */
    public function setCQueryJobTitle(array $cQueryJobTitle = array())
    {
        // validation for constraint: array
        if ('' !== ($cQueryJobTitleArrayErrorMessage = self::validateCQueryJobTitleForArrayConstraintsFromSetCQueryJobTitle($cQueryJobTitle))) {
            throw new \InvalidArgumentException($cQueryJobTitleArrayErrorMessage, __LINE__);
        }
        if (is_null($cQueryJobTitle) || (is_array($cQueryJobTitle) && empty($cQueryJobTitle))) {
            unset($this->CQueryJobTitle);
        } else {
            $this->CQueryJobTitle = $cQueryJobTitle;
        }
        return $this;
    }
    /**
     * Add item to CQueryJobTitle value
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\CQueryJobTitle $item
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfCQueryJobTitle
     */
    public function addToCQueryJobTitle(\RecruitCrm\LogicMelon\StructType\CQueryJobTitle $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \RecruitCrm\LogicMelon\StructType\CQueryJobTitle) {
            throw new \InvalidArgumentException(sprintf('The CQueryJobTitle property can only contain items of type \RecruitCrm\LogicMelon\StructType\CQueryJobTitle, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CQueryJobTitle[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \RecruitCrm\LogicMelon\StructType\CQueryJobTitle|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \RecruitCrm\LogicMelon\StructType\CQueryJobTitle|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \RecruitCrm\LogicMelon\StructType\CQueryJobTitle|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \RecruitCrm\LogicMelon\StructType\CQueryJobTitle|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \RecruitCrm\LogicMelon\StructType\CQueryJobTitle|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CQueryJobTitle
     */
    public function getAttributeName()
    {
        return 'CQueryJobTitle';
    }
}
